/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 28/03/2007
Author  : edfde                           
Company :                                 
Comments: 


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the AT90S8535


#pragma used+
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSR=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR=9;
sfrb UCR=0xa;
sfrb USR=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



//*****************************************************************
// Livrairie SSI.h
// Auteur: Philippe MARIANO
// Cre le 10/3/03
// Dernire rvision le 6/2006
// Ce fichier est destin  un projet CVAVR utilisant la carte SSI
// Il doit tre plac dans le sous rpertoire \INC
// Composant cible : AT90S8535
//*****************************************************************




// -----------------------------------------------------
// Dfinition du code des BPs de la carte AT90S8535  SSI
//------------------------------------------------------


//-----------------------------------------
//Codes de commande de l'afficheur LCD 2x16
//-----------------------------------------

// Initialisation du dplacement du curseur
//-----------------------------------------


// Affichage           code       On/Off   curseur      clignotement 
//------------------------------------------------------------------

// Dplacement du curseur ou de l'affichage
 

// ************************************************************************
//
// Prototype des fonctions gnrales de la carte SSI 
// 
// ************************************************************************
// ----------------------- Rcapitulatif ----------------------- 
// unsigned char Lire_BP(void);
// void Affiche_LCD(char *ligne1,char *ligne2);
// unsigned char eeprom_read(unsigned char addcase, unsigned int adressmap);
// void eeprom_write(unsigned char addcase, unsigned char adressmap, unsigned char data);
// void eeprom_page_read(unsigned char addcase, unsigned int adressmap, unsigned char *display_buffer);
// ************************************************************************

#pragma used+

unsigned char Lire_BP(void);
/*
Rle : Lit l'tat des BP de la carte ATMEL S_SI(PortA) 

Commentaires : La fonction renvoie le code de la touche actionne lors du premier
appel (INC = 0x1F, DEC = Ox2f, OK = 0x37, ECHAP = 0x3B, SET = 0x3D, ENTR=0x3E)
puis 0x00 si la touche est maintenue ou 0xFF si la touche est relche. 

Entres : aucunes 

sortie : code de la touche ou 0x00 ou 0xFF
*/


void Affiche_LCD(char *ligne1,char *ligne2);
/*
Rle : Gre l'affichage d'un LCD quip d'un contrleur Hitachi
       et command en mode 4 bits

Commentaires : Envoie le contenu de deux tableaux de 16 caractres sur les ligne 1 et
2 d'un afficheur LCD 2*16 caractres.
Chaque tableau doit pouvoir contenir les 16 caractres  afficher + \0

Librairie utilis : lcd.h  

Entres : ligne1, ligne2 = tableaux de 17 caractres

Sorties : Aucune
*/     
void Affiche_LCD440(char *ligne1,char *ligne2,char *ligne3, char *ligne4);

unsigned char eeprom_read(unsigned char addcase, unsigned int adressmap);
/*
Rle : Lit un octet dans une mmoire srie gre par le protocole I2C
Commentaires : A utiliser avec les mmoires > 256 octets

Librairie utilise : I2C.h

Entres :
      addcase : adresse du botier mmoire construit par 1 0 1 0 A2 A1 A0 R/W
      remarque (R/W doit tre mis  zro)
      adressmap : adresse  atteindre dans le botier     
      
Sortie : contenu de l'adresse adressmap du botier situ en addcase
*/


void eeprom_write(unsigned char addcase, unsigned char adressmap, unsigned char data);
/*
Rle : Ecrit un octet dans une mmoire srie gre par le protocole I2C

Commentaires : A utiliser avec les mmoires > 256 octets

Librairie utilise : I2C.h et delay.h

Entres :
      addcase : adresse du botier mmoire construit par 1 0 1 0 A2 A1 A0 R/W
      remarque (R/W doit tre mis  zro)
      adressmap : adresse  atteindre dans le botier
      data : octet  crire  la position adressmap du botier situ en addcase
      
Sorties : aucune

*/


void eeprom_page_read(unsigned char addcase, unsigned int adressmap, unsigned char *display_buffer);
/*
Rle : Lit 32 octets dans une mmoire srie gre par le protocole I2C

Commentaires : A utiliser avec les mmoires > 256 octets

Librairie utilise : I2C.h 

Entres :
      addcase : adresse du botier mmoire construit par 1 0 1 0 A2 A1 A0 R/W
      remarque (R/W doit tre mis  zro)
      adressmap : adresse  atteindre dans le botier          
      
Sorties : contenu des 32 adresses  partir de adressmap du botier situ en addcase
*/


int regle_HTR(unsigned char adresse,unsigned char Heure_ou_Date, char H_J, char mn_mois, int sec_annee);
// -------------------------------
// Etats du graphe reglage
// ------------------------------- 

/*                                

Rle : Rgle la date et l'heure d'une HTR PCF8583 situe  adresse (0 ou 1) 

Commentaires : La fonction permet  l'utilisateur d'effectuer le rglage de l'heure si Heure_ou_Date = 0
ou de la date si Heure_ou_Date = 1.Les paramtres H_J, mn_mois, sec_annee servent de base
aux rglages. Celui-ci s'effectue avec les BP :
INC pour augmenter une valeur,
DEC pour diminuer une valeur,
OK  pour valider la valeur modifie et passer au rglage suivant
EChap pour transfrer la valeur rgle et sortir de la fonction

Librairie utilise : PCF8583.h

Entres :
	adresse : adresse du boitier (0 ou 1 selon A0) 
	Si Heure_ou_Date = 0 (rglage de l'heure) alors -1 < H_J < 24, -1 < mn_mois < 60
							-1 < sec_annee < 60 
						  sinon -1 < H_J < 32, 0 < mn_mois < 13
							1999 < sec_annee < 2050  
Sortie : la fonction renvoie 0 
*/ 


// ************************************************************************
//
// Prototype des fonctions diverses 
// 
// ************************************************************************
// ----------------------- Rcapitulatif ----------------------- 
// unsigned char D2000_read(unsigned char adressmap);
// void D2000_write(unsigned char adressmap, unsigned char data);
// ***********************************************************************


unsigned char D2000_read(unsigned char adressmap);
/* Rle : Lit un octet dans une carte  puce D2000 (gre par le protocole I2C)

Commentaires : Mmoire eeprom de type PCF8582 (256 octets)
               Adresse du botier fige en 0xa0 
               
Librairie utilise : I2C.h

Entres : adressmap = adresse  atteindre dans le botier

Sorties : contenu de l'adresse adressmap du botier situ en 0xa0
*/
 

void D2000_write(unsigned char adressmap, unsigned char data);
/* Rle : Ecrit un octet dans une carte  puce D2000 (gre par le protocole I2C)

Commentaires : Mmoire eeprom de type PCF8582 (256 octets)
               Adresse du botier fige en 0xa0 
               
Librairie utilise : I2C.h
                
Entres : 
          adressmap = adresse  atteindre dans le botier
          data = caractre  crire
          
Sorties : aucunes
*/


// ************************************************************************
//
// Prototype des fonctions destines  la simulation des systmes du labo 
// 
// ************************************************************************

// ----------------------- Rcapitulatif -----------------------
// Fonction dveloppes pour les TP Pousse seringue
//-------------------------------------------------------------------------    

// int Regdebit(unsigned int *dizaines,unsigned int *unites, unsigned int *diziemes);
// unsigned char Select_Seringue(void);
// ************************************************************************


int Regdebit(unsigned int *dizaines,unsigned int *unites, unsigned int *diziemes);
/*
Rle : Renvoie la valeur de la consigne de dbit rgle sous la forme dizaine, unit, dizime

Commentaires : fonction crite pour le pousse seringue

Librairie utilise : lcd.h et stdio.h

Entres / sortie : dizaine de ml/h, unit ml/h, dizime ml/h
*/
 

unsigned char Menu_Select_Seringue(void);
/*Rle : Renvoie le type de seringue slectionne
	 0 : TERUMO 50CC	1 : MONOJECT/ BD 50CC	2 : BD 20CC

Commentaires : fonction crite pour le pousse seringue

Librairie utilise : lcd.h et stdio.h 

sortie : seringue slectionne 
*/

#pragma used-

#pragma library ssi.lib

// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);


char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib



// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
/*
  LCD driver routines for 4x40 alphanumeric LCD 

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  CONNECTIONS:
  
  [LCD]            [AVR Port]
  RS  (pin 11) --- bit 0
  RD  (pin 10) --- bit 1
  EN1 (pin 9) ---- bit 2
  EN2 (pin 15) --- bit 3
  DB4 (pin 4) ---- bit 4
  DB5 (pin 3) ---- bit 5
  DB6 (pin 2) ---- bit 6
  DB7 (pin 1) ---- bit 7

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/



#pragma used+

extern unsigned char _en1_msk;

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(void);

#pragma used-
#pragma library lcd4x40.lib



// Adresse CGRAM de l'afficheur LCD


// Declare your global variables here
/*--------------------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
----------------------------------------------------------------------------------------------------------------------------*/ 
char display_buffer_ligne0[17]; 	   // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	   // tampon ligne 1 de l'afficheur
char display_buffer_ligne2[17]; 	   // tampon ligne 2 de l'afficheur
char display_buffer_ligne3[17]; 	   // tampon ligne 3 de l'afficheur

// Caractre n1 : ATTENTION :
//---------------------------
const unsigned char attention[8][8] = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01}, // @0 CGRAM
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01},        // @1 CGRAM
{0x02, 0x02, 0x04, 0x05, 0x09, 0x09, 0x11, 0x11},        // @2 CGRAM
{0x08, 0x08, 0x04, 0x14, 0x12, 0x12, 0x11, 0x11},        // @3 CGRAM
{0x01, 0x01, 0x02, 0x02, 0x04, 0x04, 0x08, 0x0f},        // @4 CGRAM
{0x01, 0x01, 0x01, 0x00, 0x01, 0x01, 0x00, 0x1f},        // @5 CGRAM
{0x10, 0x10, 0x10, 0x00, 0x10, 0x10, 0x00, 0x1f},        // @6 CGRAM
{0x10, 0x10, 0x08, 0x08, 0x04, 0x04, 0x02, 0x1e}};       // @7 CGRAM     

void main(void)
{
// Declare your local variables here


// LCD module initialization
lcd_init();


                     sprintf(display_buffer_ligne0,"Etage 1");
                     sprintf(display_buffer_ligne1,"");
                     sprintf(display_buffer_ligne2,"attente appel");
                     sprintf(display_buffer_ligne3,"porte 1 deverouillee");
                     Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);


}
