/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Light
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : PPE Ascenseur 2006/2007
Version : 0.1
Date    : 19/02/2007
Author  : TOUZET / PETITJEAN
Company : Lycee Pierre-Emile MARTIN
Comments: 
Programme PPE Ascenseur
2006 / 2007


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm
/*
  CodeVisionAVR C Compiler
  (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for I2C bus master functions

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE I2C BUS IS CONNECTED AND
  THE DATA BITS USED FOR SDA & SCL

  EXAMPLE FOR PORTB:

    #asm
        .equ __i2c_port=0x18
        .equ __sda_bit=3
        .equ __scl_bit=4
    #endasm
    #include <i2c.h>
*/


#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-



// Afficheur LCD
#asm
   .equ __lcd_port=0x15
#endasm
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib



// Chargement des librairies
// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the AT90S8535


#pragma used+
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSR=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR=9;
sfrb UCR=0xa;
sfrb USR=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);


char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib



// External Interrupt 0 service routine
interrupt [2] void ext_int0_isr(void)
{


//interrption INT0  cabler entre la carte SSI et la carte interface I2C


}
 
// Adresse CGRAM de l'afficheur LCD

// Adresses des Ports I2C


/*--------------------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
----------------------------------------------------------------------------------------------------------------------------*/ 
char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	       		// tampon ligne 1 de l'afficheur
char display_buffer_ligne2[17]; 			// tampon ligne 2 de l'afficheur
char display_buffer_ligne3[17]; 	       		// tampon ligne 3 de l'afficheur


// Caractres personnaliss placs dans la mmoire CGRAM du LCD
const unsigned char XXX[] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};         	     // @0 CGRAM
const unsigned char XXX[] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};                // @1 CGRAM
const unsigned char XXX[] = {0x00, 0x0E, 0x0A, 0x0A, 0x0A, 0x0A, 0x1B, 0x00};    	     // @2 CGRAM
const unsigned char XXX[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00};                // @3 CGRAM
const unsigned char XXX[] = {0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00};                // @4 CGRAM
const unsigned char XXX[] = {0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00};                // @5 CGRAM
const unsigned char XXX[] = {0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00};                // @6 CGRAM
const unsigned char XXX[] = {0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00};                // @7 CGRAM                


void main(void)
{
// Declare your local variables here
/*--------------------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
----------------------------------------------------------------------------------------------------------------------------*/

// Input/Output Ports initialization
// Port A initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
// State0=0 State1=0 State2=0 State3=0 State4=0 State5=0 State6=0 State7=0 
PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: Off
GIMSK=0x40;
MCUCR=0x03;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;

// I2C Bus initialisation
i2c_init();

// LCD module initialisation
lcd_init(20);        

// Chargement de la mmoire CGRAM de l'afficheur avec les 
// caractres personaliss
for (i=0;i<8;i++)
lcd_write_byte(0x40              + i, caractre...[i]);
for (i=0;i<8;i++)
lcd_write_byte(0x48		    + i, caractre...[i]); 
for (i=0;i<8;i++)
lcd_write_byte(0x50              + i, caractre...[i]);
for (i=0;i<8;i++)
lcd_write_byte(0x58              + i, caractre...[i]);
for (i=0;i<8;i++)
lcd_write_byte(0x60              + i, caractre...[i]);
for (i=0;i<8;i++)
lcd_write_byte(0x68              + i, caractre...[i]); 
for (i=0;i<8;i++)
lcd_write_byte(0x70              + i, caractre...[i]);
for (i=0;i<8;i++)
lcd_write_byte(0x78              + i, caractre...[i]);

// Dfinition des variables
unsigned char Lire_PCF8574(unsigned char add);
unsigned char Ecrire_valeur(unsigned char x, unsigned char y);
unsigned char etat,i,j,PO1,PO2,PO3,PC1,PC2,PC3,AP1,AP2,AP3;
unsigned char AC1,AC2,AC3,VP1,VP2,VP3,EL1,EL2,EL3,DEF,LED1;
unsigned char LED2,LED3,OPTO1,OPTO2,OPTO3,PWM;

// Prototype des fonctions
void Ecrire_PCF8574(unsigned char add, unsigned char valeur_portD);
void PWM1(unsigned long alpha1);
void SP1(rampe accel);
void SP2(rampe decel);

void PWM1(unsigned long alpha1)
    {
    unsigned short maxi;
    maxi=0x00FF;
    OCR1A=maxi-(((100-alpha1) * maxi)/100);
    }

void SP1(rampe accel)
    {
     i=0;
     do
      {
      i=i+1;
      delay_ms(10);
      PWM1(i);
      }
     while (((i<255)));
    }

void SP2(rampe decel)
    {
     i=0;
     do
      {
      j=j+1;
      delay_ms(10);
      PWM1(j);
      }
     while (((j<255)));
    }

// Global enable interrupts
#asm("sei")

// initialisation :
//----------------
sprintf(display_buffer_ligne0,"   PPE ascenseur");
sprintf(display_buffer_ligne1,"    2006 / 2007");
sprintf(display_buffer_ligne2,"     Carte SSI");
sprintf(display_buffer_ligne3,"  Lyce P-E MARTIN");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
delay_ms(4000);

//initialisation : faire descendre la cabine jusqu' l'tage
while ((1))                     
 {
 PC1 = Lire_PCF8574(1)&0b00000001;        //entres port A
 LED1 = Ecrire_PCF8574(3) 0b00000100      //  revoir
 LED2 = Ecrire_PCF8574(3) 0b00000101      //  revoir
 LED3 = Ecrire_PCF8574(3) 0b00000110      //  revoir
 DEF = Ecrire_PCF8574(3) 0b00000111       //  revoir

  while (((PC1==0)))                         
    {
    PWM1(255);
    LED1=1;
    LED2=1;
    LED3=1;
    DEF=1;
    delay_ms(500);
    LED1=0;
    LED2=0;
    LED3=0;
    DEF=0;
    }
  PWM1(0);
 }



//commander le moteur jusqu' ce que PC1=1
//ET en mme temps allumer les 3 LED (LED1.LED2.LED3)
//ET en mme temps afficher :
sprintf(display_buffer_ligne0,"   Initialisation");
sprintf(display_buffer_ligne1,"        ----");
sprintf(display_buffer_ligne2,"  Mode Autonome");
sprintf(display_buffer_ligne3,"  Monte interdite");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);

while (1)
      {
      AP1 = Lire_PCF8574(0)&0b01000000;        //entres port A et B
      AP2 = Lire_PCF8574(0)&0b10000000;
      AP3 = Lire_PCF8574(1)&0b00000001;
      
      AC1 = Lire_PCF8574(1)&0b00000010;        //entres port B
      AC2 = Lire_PCF8574(1)&0b00000100;
      AC3 = Lire_PCF8574(1)&0b00001000;
      
      PO1 = Lire_PCF8574(0)&0b00001000;        //entres port A
      PO2 = Lire_PCF8574(0)&0b00010000;
      PO3 = Lire_PCF8574(0)&0b00100000;
      
      VP1 = Lire_PCF8574(2)&0b00000001;        //entres port C
      VP2 = Lire_PCF8574(2)&0b00000010;
      VP3 = Lire_PCF8574(2)&0b00000100;
      
      PC1 = Lire_PCF8574(1)&0b00000001;        //entres port A
      PC2 = Lire_PCF8574(1)&0b00000010;
      PC3 = Lire_PCF8574(1)&0b00000100;
      
 /*   commandes de sorties : a revoir
      EL1 = Ecrire_PCF8574(AD_I2C_PORTD,0bOOOOOOO1);        //sorties port D
      EL2 = Ecrire_PCF8574(3) 0bOOOOOO1O
      EL3 = Ecrire_PCF8574(3) 0b00000011
      LED1 = Ecrire_PCF8574(3) 0b00000100
      LED2 = Ecrire_PCF8574(3) 0b00000101
      LED3 = Ecrire_PCF8574(3) 0b00000110
      DEF = Ecrire_PCF8574(3) 0b00000111      */
      
      
      switch (etat);
      case etage_1 : EL1 = 1;
                     LED1 = 1;
                     sprintf(display_buffer_ligne0,"Etage 1");
                     sprintf(display_buffer_ligne1,"");
                     sprintf(display_buffer_ligne2,"attente appel");
                     sprintf(display_buffer_ligne3,"porte 1 deverouillee");
                     Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                if ((AP2 == 1)||(AC2 == 1));
       	       	 {
       	  	   do//crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
       	  	    {
       	  	    sprintf(display_buffer_ligne0,"etage 2 demand");
       	  	    sprintf(display_buffer_ligne1,"");
                    sprintf(display_buffer_ligne2,"fermer la porte !");
       	            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	            etat = MC;
                    while(PO1=1);
                    }
                 }    
       	       	else if  ((AP3 == 1)||(AC3 == 1))
       	       	 {
       	  	   do//crire ce qui suit TANT QUE porte 1 ouverte (tant que PO1=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 3 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	           etat = ML;
       	           while(PO1=1);
       	           }
                 }
                else etat = etage_1;
      break;
      case etage_2 :  EL2 = 1;
                      LED2 = 1;
                      sprintf(display_buffer_ligne0,"Etage 2");
                      sprintf(display_buffer_ligne1,"");
                      sprintf(display_buffer_ligne2,"attente appel");
                      sprintf(display_buffer_ligne3,"porte 2 deverouillee");
                      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                if ((AP1 == 1)||(AC1 == 1));
                 {
       	  	   do//crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	           etat = DC;
       	           while(PO2=1); 
                   }
                 }
       	       	else if  ((AP3 == 1)||(AC3 == 1))
       	       	 {
       	  	   do//crire ce qui suit TANT QUE porte 2 ouverte (tant que PO2=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 3 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	           etat = ML;
                   while(PO2=1);
                   }
                 }
       	       	else etat = etage_2;
      break;
      case etage_3 :  EL3 = 1;
                      LED3 = 1;
                      sprintf(display_buffer_ligne0,"etage 3");
                      sprintf(display_buffer_ligne1,"");
                      sprintf(display_buffer_ligne2,"attente appel");
                      sprintf(display_buffer_ligne3,"porte 3 deverouillee");
                      Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
                if ((AP1 == 1)||(AC1 == 1));
                 {
       	  	   do//crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 1 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	           etat = DL; 
                   while(PO3=1);
                   }
                 }
       	       	else if  ((AP2 == 1)||(AC2 == 1))
       	       	 {
       	  	   do//crire ce qui suit TANT QUE porte 3 ouverte (tant que PO3=1)
       	  	   {
       	  	   sprintf(display_buffer_ligne0,"etage 2 demand");
       	  	   sprintf(display_buffer_ligne1,"");
                   sprintf(display_buffer_ligne2,"fermer la porte !");
       	           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2);
       	           etat = DC;
       	           while(PO3=1);
                   }
                 }
                 else etat = etage_3
      break;
      case MC : PWM1(0);
                while ((1))                     
                 {
                while (((PO1==0))||((PO2==0))||((PO3==0)))                        
                 {
                 }
                 if (((VP1==1)&&(VP2==1)&&(VP3==1)))                            
                  {
                  SP1(rampe accel);
                  delay_ms(500);
                  SP2(rampe decel);
                  }
                 else
                  {
                  etat=erreur;
                  };
                while (((PC2==0))||((PC3==0)))                                
                  {
                  }
                  PWM1(0);
                  if (((PC2==1)))                        
                   {
                   etat=etage_2;
                   }
                  else
                   {
                   if (((PC3==1)))                        
                   {
                   etat=etage_3;
                   }
                  else
                   {
                   etat=erreur;
                   };
                   };
                 }
      break; 	
      case DC : PWM(0);
                while ((1))                     
                 {
                while (((PO1==0))||((PO2==0))||((PO3==0)))                        
                 {
                 }
                 if (((VP1==1)&&(VP2==1)&&(VP3==1)))                            
                  {
                  SP1(rampe accel);
                  delay_ms(500);
                  SP2(rampe decel);
                  }
                 else
                  {
                  etat=erreur;
                  };
                while (((PC2==0))||((PC1==0)))                                
                  {
                  }
                  PWM1(0);
                  if (((PC2==1)))                        
                   {
                   etat=etage_2;
                   }
                  else
                   {
                   if (((PC1==1)))                        
                   {
                   etat=etage_1;
                   }
                  else
                   {
                   etat=erreur;
                   };
                   };
                 }
      break;
      case ML : PWM(0);
                while ((1))                     
                 {
                while (((PO1==0))||((PO2==0))||((PO3==0)))                        
                 {
                 }
                 if (((VP1==1)&&(VP2==1)&&(VP3==1)))                            
                  {
                  SP1(rampe accel);
                  delay_ms(1000);
                  SP2(rampe decel);
                  }
                 else
                  {
                  etat=erreur;
                  };
                while (((PC2==0))||((PC3==0)))                                
                  {
                  }
                  PWM1(0);
                  if (((PC2==1)))                        
                   {
                   etat=etage_2;
                   }
                  else
                   {
                   if (((PC3==1)))                        
                   {
                   etat=etage_3;
                   }
                  else
                   {
                   etat=erreur;
                   };
                   };
                 }
      break;
      case DL : PWM(0);
                while ((1))                     
                 {
                while (((PO1==0))||((PO2==0))||((PO3==0)))                        
                 {
                 }
                 if (((VP1==1)&&(VP2==1)&&(VP3==1)))                            
                  {
                  SP1(rampe accel);
                  delay_ms(1000);
                  SP2(rampe decel);
                  }
                 else
                  {
                  etat=erreur;
                  };
                while (((PC1==0))||((PC2==0)))                                
                  {
                  }
                  PWM1(0);
                  if (((PC2==1)))                        
                   {
                   etat=etage_2;
                   }
                  else
                   {
                   if (((PC1==1)))                        
                   {
                   etat=etage_1;
                   }
                  else
                   {
                   etat=erreur;
                   };
                   };
                 }
      break;

      };
}
        
