/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Light
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : PPE Ascenseur 2006/2007
Version : 0.2
Date    : 19/02/2007
Author  : TOUZET / PETITJEAN / MOREUX
Company : Lycee Pierre-Emile MARTIN
Comments: 
Programme PPE Ascenseur
2006 / 2007


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

// Chargement des librairies
#include <90s8535.h>    // librairie C ATMEL AT90S8535
#include <delay.h>      // Fonction delai
#include <ssi.h> 	// SP de dcodage de la trame issue du clavier PS2 et SP Afficheur LCD
#include <stdio.h>	// Fonctions standard entres / sorties

// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm
#include <i2c.h>

// Afficheur LCD
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>

/*--------------------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
----------------------------------------------------------------------------------------------------------------------------*/ 
char display_buffer_ligne0[17]; 	   // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	   // tampon ligne 1 de l'afficheur
char display_buffer_ligne2[17]; 	   // tampon ligne 2 de l'afficheur
char display_buffer_ligne3[17]; 	   // tampon ligne 3 de l'afficheur
//unsigned char EL1, EL2, EL3;		   // Etat des lectro-aimants

// Programme d'interruption
interrupt [EXT_INT0] void ext_int0_isr(void)
{
//interrption INT0  cabler entre la carte SSI et la carte interface I2C
}

// Adresse CGRAM de l'afficheur LCD
#define Add_Caract0_CGRAM 0x40             //caractre 0
#define Add_Caract1_CGRAM 0x48		   //caractre 1
#define Add_Caract2_CGRAM 0x50             //caractre 2
#define Add_Caract3_CGRAM 0x58             //caractre 3
#define Add_Caract4_CGRAM 0x60             //caractre 4
#define Add_Caract5_CGRAM 0x68             //caractre 5
#define Add_Caract6_CGRAM 0x70             //caractre 6
#define Add_Caract7_CGRAM 0x78             //caractre 7

// Adresses des Ports I2C
#define AD_BASE_PCF8574		0x40       // base I2C
#define AD_I2C_PORTA		0          // port A
#define AD_I2C_PORTB		1          // port B
#define AD_I2C_PORTC		2	   // port C
#define AD_I2C_PORTD		3          // port D

// Adresses des ports I2C
#define I2C_PORTA 0
#define I2C_PORTB 1
#define I2C_PORTC 2
#define I2C_PORTD 3

// Etat du graphe
#define test_1	  0
#define	test_2	  1
#define test_3    2
#define test_4    5

// Prototype des fonctions :
void Ecrire_PCF8574(unsigned char add, unsigned char valeur);
void init_CGRAM(char valeur[8][8]);
unsigned char Lire_PCF8574(unsigned char add);

// Caractres personnaliss placs dans la mmoire CGRAM du LCD

// Caractre n1 : ATTENTION :
//---------------------------
const unsigned char attention[8][8] = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01}, // @0 CGRAM
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01},        // @1 CGRAM
{0x02, 0x02, 0x04, 0x05, 0x09, 0x09, 0x11, 0x11},        // @2 CGRAM
{0x08, 0x08, 0x04, 0x14, 0x12, 0x12, 0x11, 0x11},        // @3 CGRAM
{0x01, 0x01, 0x02, 0x02, 0x04, 0x04, 0x08, 0x0f},        // @4 CGRAM
{0x01, 0x01, 0x01, 0x00, 0x01, 0x01, 0x00, 0x1f},        // @5 CGRAM
{0x10, 0x10, 0x10, 0x00, 0x10, 0x10, 0x00, 0x1f},        // @6 CGRAM
{0x10, 0x10, 0x08, 0x08, 0x04, 0x04, 0x02, 0x1e}};       // @7 CGRAM                

void main(void)
{
/*--------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
--------------------------------------------------------------------------------------------------------------*/
unsigned char etat,OCR1AL,OCR1BL;
unsigned char PO1,PO2,PO3;
unsigned char PC1,PC2,PC3;
unsigned char AP1,AP2,AP3;
unsigned char AC1,AC2,AC3;
unsigned char VP1,VP2,VP3;
//unsigned char LED1,LED2,LED3;
//unsigned char DEF;
//unsigned char coef;
unsigned char EtatPORTA,EtatPORTB,EtatPORTC,EtatPORTD; 

// Port A initialization
PORTA=0x00;
DDRA=0x00;

// Port B initialization
PORTB=0x00;
DDRB=0x00;

// Port C initialization
PORTC=0x00;
DDRC=0x00;

// Port D initialization
PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
TCCR1A=0xA1;
TCCR1B=0x04;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
GIMSK=0x40;
MCUCR=0x03;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
ACSR=0x80;

// I2C Bus initialisation
i2c_init();

// LCD module initialisation
//lcd_init(20);        

// Global enable interrupts
#asm("sei")

// initialisation :

{
sprintf(display_buffer_ligne0,"   PPE ascenseur");
sprintf(display_buffer_ligne1,"    2006 / 2007");
sprintf(display_buffer_ligne2,"     Carte SSI");
sprintf(display_buffer_ligne3,"  Lyce P-E MARTIN");
Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
delay_ms(4000);

etat=test_1;
}

//fin initialisation

while (1)
      {
      switch (etat)
      {
      case test_1 : init_CGRAM(attention);
                    lcd_gotoxy(17,0);		// caractre perso (ATTENTION) ligne 0
		    lcd_putchar(0);
		    lcd_gotoxy(18,0);
		    lcd_putchar(1);
		    lcd_gotoxy(17,1);           // caractre perso (ATTENTION) ligne 1
		    lcd_putchar(2);
		    lcd_gotoxy(18,1);
		    lcd_putchar(3);
		    lcd_gotoxy(16,2);           // caractre perso (ATTENTION) ligne 2
		    lcd_putchar(4);
		    lcd_gotoxy(17,2);
		    lcd_putchar(5);
		    lcd_gotoxy(18,2);
		    lcd_putchar(6);
		    lcd_gotoxy(19,2);
		    lcd_putchar(7);              
		    lcd_gotoxy(1,2);		// affichage de l'tat du test
		    lcd_putchar(etat);
		    EtatPORTD=EtatPORTD | 0b00000001;		// DEF = 1
      		    Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
      		    
      		    if (AC1 == 1) etat=test_2;
      		    if (AC2 == 1) etat=test_3;
      		    if (AC3 == 1) etat=test_4;
      		    	else etat=test_1;
      break;
      
      case test_2 :
      	     if (AC1 == 1)
	      	{
      		sprintf(display_buffer_ligne0,"AC1=1");
       		sprintf(display_buffer_ligne1,"bouton enfonc");       
       		sprintf(display_buffer_ligne2,"");
      	 	sprintf(display_buffer_ligne3,"--> appel etage 1");
       		Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
       		EtatPORTD=EtatPORTD | 0b00010000;            // LED1 = 1
       	        Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
        	}
             else EtatPORTD=EtatPORTD & 0b11101111;          // LED1 = 0
                  Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
      	     
      	     if (AC2 == 1) etat=test_3;
      	     if (AC3 == 1) etat=test_4;
      	      	else etat=test_2;
                    
      break;
      
      case test_3 :
      	     if (AC2 == 1)
	      	{
      		sprintf(display_buffer_ligne0,"AC2=1");
       		sprintf(display_buffer_ligne1,"bouton enfonc");       
       		sprintf(display_buffer_ligne2,"");
      	 	sprintf(display_buffer_ligne3,"--> appel etage 2");
       		Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
       		EtatPORTD=EtatPORTD | 0b00100000;            // LED2 = 1
       	        Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
        	}
             else EtatPORTD=EtatPORTD & 0b11011111;	     // LED2 = 0
                  Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
             
             if (AC1 == 1) etat=test_2;
      	     if (AC3 == 1) etat=test_4;
      	      	else etat=test_3;
                    
      break;
      
      case test_4 :
      	     if (AC3 == 1)
	      	{
      		sprintf(display_buffer_ligne0,"AC3=1");
       		sprintf(display_buffer_ligne1,"bouton enfonc");       
       		sprintf(display_buffer_ligne2,"");
      	 	sprintf(display_buffer_ligne3,"--> appel etage 3");
       		Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
       		EtatPORTD=EtatPORTD | 0b01000000;            // LED3 = 1
       	        Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
        	}
             else EtatPORTD=EtatPORTD & 0b10111111;	     // LED3 = 0
                  Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
             
             if (AC1 == 1) etat=test_2;
      	     if (AC2 == 1) etat=test_3;
      	      	else etat=test_4;
                    
      break;     
   }
  };

AP1 = (Lire_PCF8574(I2C_PORTA)&0b01000000);        // lecture PA6
AP2 = (Lire_PCF8574(I2C_PORTA)&0b10000000);        // lecture PA7
AP3 = (Lire_PCF8574(I2C_PORTB)&0b00000001);        // lecture PB0
AC1 = (Lire_PCF8574(I2C_PORTB)&0b00000010);        // lecture PB1
AC2 = (Lire_PCF8574(I2C_PORTB)&0b00000100);        // lecture PB2
AC3 = (Lire_PCF8574(I2C_PORTB)&0b00001000);        // lecture PB3
PO1 = (Lire_PCF8574(I2C_PORTA)&0b00001000);        // lecture PA3
PO2 = (Lire_PCF8574(I2C_PORTA)&0b00010000);        // lecture PA4
PO3 = (Lire_PCF8574(I2C_PORTA)&0b00100000);        // lecture PA5
VP1 = (Lire_PCF8574(I2C_PORTC)&0b00000001);        // lecture PC0
VP2 = (Lire_PCF8574(I2C_PORTC)&0b00000010);        // lecture PC1
VP3 = (Lire_PCF8574(I2C_PORTC)&0b00000100);        // lecture PC2
PC1 = (Lire_PCF8574(I2C_PORTA)&0b00000001);        // lecture PA0
PC2 = (Lire_PCF8574(I2C_PORTA)&0b00000010);        // lecture PA1
PC3 = (Lire_PCF8574(I2C_PORTA)&0b00000100);        // lecture PA2

EtatPORTA = (Lire_PCF8574(I2C_PORTA));             // lecture du port A
EtatPORTB = (Lire_PCF8574(I2C_PORTB));             // Lecture du port B
EtatPORTC = (Lire_PCF8574(I2C_PORTC));             // Lecture du port C
EtatPORTD = (Lire_PCF8574(I2C_PORTD));             // Lecture du port D
                                        
EtatPORTD=EtatPORTD | 0b00010000;	// LED1 = 1
EtatPORTD=EtatPORTD & 0b11101111;	// LED1 = 0		

EtatPORTD=EtatPORTD | 0b00100000;	// LED2 = 1
EtatPORTD=EtatPORTD & 0b11011111;	// LED2 = 0
                                       
EtatPORTD=EtatPORTD | 0b01000000;	// LED3 = 1
EtatPORTD=EtatPORTD & 0b10111111;	// LED3 = 0

EtatPORTD=EtatPORTD | 0b00000010;	// EL1 = 1
EtatPORTD=EtatPORTD & 0b11111101;	// EL1 = 0

EtatPORTD=EtatPORTD | 0b00000100;	// EL2 = 1
EtatPORTD=EtatPORTD & 0b11111011;	// EL2 = 0

EtatPORTD=EtatPORTD | 0b00001000;	// EL3 = 1
EtatPORTD=EtatPORTD & 0b11110111;	// EL3 = 0

EtatPORTD=EtatPORTD | 0b00000001;	// DEF = 1
EtatPORTD=EtatPORTD & 0b11111110;	// DEF = 0

Ecrire_PCF8574(I2C_PORTD,EtatPORTD);
}

//fin du programme principal


// Sous-programmes
//----------------
    
unsigned char Lire_PCF8574(unsigned char add)          // Procdure de lecture du port I2C
{
  unsigned char entrees;
  i2c_start();
  i2c_write(0x41 | add << 1);
  entrees = i2c_read(0);
  i2c_stop();
  return entrees;    
} 


void Ecrire_PCF8574(unsigned char add, unsigned char valeur)           // Procdure d'criture sur le port I2C
{
  i2c_start();
  i2c_write(0x40 | add << 1);
  i2c_write(valeur);
  i2c_stop();
  delay_ms(10);
} 

/*

void EL1_egal_1()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD | 0b00000010;	//EL1=1 
Ecrire_PCF8574(PORTD,EtatPORTD); 	//EL1=1;
}         
 
*/


void init_CGRAM(char valeur[8][8])
 {
 unsigned char i,j;
 for (i=0;i<8;i++)
  {
   for (j=0;j<8;j++)
   	lcd_write_byte(Add_Caract0_CGRAM + i, valeur[i][j]);
    }
 }