/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Light
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : PPE Ascenseur 2006/2007
Version : 0.2
Date    : 19/02/2007
Author  : TOUZET / PETITJEAN / MOREUX
Company : Lycee Pierre-Emile MARTIN
Comments: 
Programme PPE Ascenseur
2006 / 2007


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

// Chargement des librairies
// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the AT90S8535


#pragma used+
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSR=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR=9;
sfrb UCR=0xa;
sfrb USR=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

//*****************************************************************
// Livrairie SSI.h
// Auteur: Philippe MARIANO
// Cre le 10/3/03
// Dernire rvision le 6/2006
// Ce fichier est destin  un projet CVAVR utilisant la carte SSI
// Il doit tre plac dans le sous rpertoire \INC
// Composant cible : AT90S8535
//*****************************************************************




// -----------------------------------------------------
// Dfinition du code des BPs de la carte AT90S8535  SSI
//------------------------------------------------------


//-----------------------------------------
//Codes de commande de l'afficheur LCD 2x16
//-----------------------------------------

// Initialisation du dplacement du curseur
//-----------------------------------------


// Affichage           code       On/Off   curseur      clignotement 
//------------------------------------------------------------------

// Dplacement du curseur ou de l'affichage
 

// ************************************************************************
//
// Prototype des fonctions gnrales de la carte SSI 
// 
// ************************************************************************
// ----------------------- Rcapitulatif ----------------------- 
// unsigned char Lire_BP(void);
// void Affiche_LCD(char *ligne1,char *ligne2);
// unsigned char eeprom_read(unsigned char addcase, unsigned int adressmap);
// void eeprom_write(unsigned char addcase, unsigned char adressmap, unsigned char data);
// void eeprom_page_read(unsigned char addcase, unsigned int adressmap, unsigned char *display_buffer);
// ************************************************************************

#pragma used+

unsigned char Lire_BP(void);
/*
Rle : Lit l'tat des BP de la carte ATMEL S_SI(PortA) 

Commentaires : La fonction renvoie le code de la touche actionne lors du premier
appel (INC = 0x1F, DEC = Ox2f, OK = 0x37, ECHAP = 0x3B, SET = 0x3D, ENTR=0x3E)
puis 0x00 si la touche est maintenue ou 0xFF si la touche est relche. 

Entres : aucunes 

sortie : code de la touche ou 0x00 ou 0xFF
*/


void Affiche_LCD(char *ligne1,char *ligne2);
/*
Rle : Gre l'affichage d'un LCD quip d'un contrleur Hitachi
       et command en mode 4 bits

Commentaires : Envoie le contenu de deux tableaux de 16 caractres sur les ligne 1 et
2 d'un afficheur LCD 2*16 caractres.
Chaque tableau doit pouvoir contenir les 16 caractres  afficher + \0

Librairie utilis : lcd.h  

Entres : ligne1, ligne2 = tableaux de 17 caractres

Sorties : Aucune
*/     
void Affiche_LCD440(char *ligne1,char *ligne2,char *ligne3, char *ligne4);

unsigned char eeprom_read(unsigned char addcase, unsigned int adressmap);
/*
Rle : Lit un octet dans une mmoire srie gre par le protocole I2C
Commentaires : A utiliser avec les mmoires > 256 octets

Librairie utilise : I2C.h

Entres :
      addcase : adresse du botier mmoire construit par 1 0 1 0 A2 A1 A0 R/W
      remarque (R/W doit tre mis  zro)
      adressmap : adresse  atteindre dans le botier     
      
Sortie : contenu de l'adresse adressmap du botier situ en addcase
*/


void eeprom_write(unsigned char addcase, unsigned char adressmap, unsigned char data);
/*
Rle : Ecrit un octet dans une mmoire srie gre par le protocole I2C

Commentaires : A utiliser avec les mmoires > 256 octets

Librairie utilise : I2C.h et delay.h

Entres :
      addcase : adresse du botier mmoire construit par 1 0 1 0 A2 A1 A0 R/W
      remarque (R/W doit tre mis  zro)
      adressmap : adresse  atteindre dans le botier
      data : octet  crire  la position adressmap du botier situ en addcase
      
Sorties : aucune

*/


void eeprom_page_read(unsigned char addcase, unsigned int adressmap, unsigned char *display_buffer);
/*
Rle : Lit 32 octets dans une mmoire srie gre par le protocole I2C

Commentaires : A utiliser avec les mmoires > 256 octets

Librairie utilise : I2C.h 

Entres :
      addcase : adresse du botier mmoire construit par 1 0 1 0 A2 A1 A0 R/W
      remarque (R/W doit tre mis  zro)
      adressmap : adresse  atteindre dans le botier          
      
Sorties : contenu des 32 adresses  partir de adressmap du botier situ en addcase
*/


int regle_HTR(unsigned char adresse,unsigned char Heure_ou_Date, char H_J, char mn_mois, int sec_annee);
// -------------------------------
// Etats du graphe reglage
// ------------------------------- 

/*                                

Rle : Rgle la date et l'heure d'une HTR PCF8583 situe  adresse (0 ou 1) 

Commentaires : La fonction permet  l'utilisateur d'effectuer le rglage de l'heure si Heure_ou_Date = 0
ou de la date si Heure_ou_Date = 1.Les paramtres H_J, mn_mois, sec_annee servent de base
aux rglages. Celui-ci s'effectue avec les BP :
INC pour augmenter une valeur,
DEC pour diminuer une valeur,
OK  pour valider la valeur modifie et passer au rglage suivant
EChap pour transfrer la valeur rgle et sortir de la fonction

Librairie utilise : PCF8583.h

Entres :
	adresse : adresse du boitier (0 ou 1 selon A0) 
	Si Heure_ou_Date = 0 (rglage de l'heure) alors -1 < H_J < 24, -1 < mn_mois < 60
							-1 < sec_annee < 60 
						  sinon -1 < H_J < 32, 0 < mn_mois < 13
							1999 < sec_annee < 2050  
Sortie : la fonction renvoie 0 
*/ 


// ************************************************************************
//
// Prototype des fonctions diverses 
// 
// ************************************************************************
// ----------------------- Rcapitulatif ----------------------- 
// unsigned char D2000_read(unsigned char adressmap);
// void D2000_write(unsigned char adressmap, unsigned char data);
// ***********************************************************************


unsigned char D2000_read(unsigned char adressmap);
/* Rle : Lit un octet dans une carte  puce D2000 (gre par le protocole I2C)

Commentaires : Mmoire eeprom de type PCF8582 (256 octets)
               Adresse du botier fige en 0xa0 
               
Librairie utilise : I2C.h

Entres : adressmap = adresse  atteindre dans le botier

Sorties : contenu de l'adresse adressmap du botier situ en 0xa0
*/
 

void D2000_write(unsigned char adressmap, unsigned char data);
/* Rle : Ecrit un octet dans une carte  puce D2000 (gre par le protocole I2C)

Commentaires : Mmoire eeprom de type PCF8582 (256 octets)
               Adresse du botier fige en 0xa0 
               
Librairie utilise : I2C.h
                
Entres : 
          adressmap = adresse  atteindre dans le botier
          data = caractre  crire
          
Sorties : aucunes
*/


// ************************************************************************
//
// Prototype des fonctions destines  la simulation des systmes du labo 
// 
// ************************************************************************

// ----------------------- Rcapitulatif -----------------------
// Fonction dveloppes pour les TP Pousse seringue
//-------------------------------------------------------------------------    

// int Regdebit(unsigned int *dizaines,unsigned int *unites, unsigned int *diziemes);
// unsigned char Select_Seringue(void);
// ************************************************************************


int Regdebit(unsigned int *dizaines,unsigned int *unites, unsigned int *diziemes);
/*
Rle : Renvoie la valeur de la consigne de dbit rgle sous la forme dizaine, unit, dizime

Commentaires : fonction crite pour le pousse seringue

Librairie utilise : lcd.h et stdio.h

Entres / sortie : dizaine de ml/h, unit ml/h, dizime ml/h
*/
 

unsigned char Menu_Select_Seringue(void);
/*Rle : Renvoie le type de seringue slectionne
	 0 : TERUMO 50CC	1 : MONOJECT/ BD 50CC	2 : BD 20CC

Commentaires : fonction crite pour le pousse seringue

Librairie utilise : lcd.h et stdio.h 

sortie : seringue slectionne 
*/

#pragma used-

#pragma library ssi.lib

// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);


char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib



// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm
/*
  CodeVisionAVR C Compiler
  (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for I2C bus master functions

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE I2C BUS IS CONNECTED AND
  THE DATA BITS USED FOR SDA & SCL

  EXAMPLE FOR PORTB:

    #asm
        .equ __i2c_port=0x18
        .equ __sda_bit=3
        .equ __scl_bit=4
    #endasm
    #include <i2c.h>
*/


#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-



// Afficheur LCD
#asm
   .equ __lcd_port=0x15
#endasm
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib



/*--------------------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
----------------------------------------------------------------------------------------------------------------------------*/ 
char display_buffer_ligne0[17]; 	   // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	   // tampon ligne 1 de l'afficheur
char display_buffer_ligne2[17]; 	   // tampon ligne 2 de l'afficheur
char display_buffer_ligne3[17]; 	   // tampon ligne 3 de l'afficheur
//unsigned char EL1, EL2, EL3;		   // Etat des lectro-aimants

// Programme d'interruption
interrupt [2] void ext_int0_isr(void)
{
//interrption INT0  cabler entre la carte SSI et la carte interface I2C
}

// Adresse CGRAM de l'afficheur LCD

// Adresses des Ports I2C

// Adresses des ports I2C

// Etat du graphe

// Prototype des fonctions :
void Ecrire_PCF8574(unsigned char add, unsigned char valeur);
void init_CGRAM(char valeur[8][8]);
unsigned char Lire_PCF8574(unsigned char add);

// Caractres personnaliss placs dans la mmoire CGRAM du LCD

// Caractre n1 : ATTENTION :
//---------------------------
const unsigned char attention[8][8] = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01}, // @0 CGRAM
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01},        // @1 CGRAM
{0x02, 0x02, 0x04, 0x05, 0x09, 0x09, 0x11, 0x11},        // @2 CGRAM
{0x08, 0x08, 0x04, 0x14, 0x12, 0x12, 0x11, 0x11},        // @3 CGRAM
{0x01, 0x01, 0x02, 0x02, 0x04, 0x04, 0x08, 0x0f},        // @4 CGRAM
{0x01, 0x01, 0x01, 0x00, 0x01, 0x01, 0x00, 0x1f},        // @5 CGRAM
{0x10, 0x10, 0x10, 0x00, 0x10, 0x10, 0x00, 0x1f},        // @6 CGRAM
{0x10, 0x10, 0x08, 0x08, 0x04, 0x04, 0x02, 0x1e}};       // @7 CGRAM                

void main(void)
{
/*--------------------------------------------------------------------------------------------------------------
type 			Dsignation				      Commentaires		       
--------------------------------------------------------------------------------------------------------------*/
unsigned char etat,OCR1AL,OCR1BL;
unsigned char PO1,PO2,PO3;
unsigned char PC1,PC2,PC3;
unsigned char AP1,AP2,AP3;
unsigned char AC1,AC2,AC3;
unsigned char VP1,VP2,VP3;
//unsigned char LED1,LED2,LED3;
//unsigned char DEF;
//unsigned char coef;
unsigned char EtatPORTA,EtatPORTB,EtatPORTC,EtatPORTD; 

// Port A initialization
PORTA=0x00;
DDRA=0x00;

// Port B initialization
PORTB=0x00;
DDRB=0x00;

// Port C initialization
PORTC=0x00;
DDRC=0x00;

// Port D initialization
PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
TCCR1A=0xA1;
TCCR1B=0x04;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
GIMSK=0x40;
MCUCR=0x03;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
ACSR=0x80;

// I2C Bus initialisation
i2c_init();

// LCD module initialisation
//lcd_init(20);        

// Global enable interrupts
#asm("sei")

// initialisation :

{
sprintf(display_buffer_ligne0,"   PPE ascenseur");
sprintf(display_buffer_ligne1,"    2006 / 2007");
sprintf(display_buffer_ligne2,"     Carte SSI");
sprintf(display_buffer_ligne3,"  Lyce P-E MARTIN");
Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
delay_ms(4000);

etat=0;
}

//fin initialisation

while (1)
      {
      switch (etat)
      {
      case 0 : init_CGRAM(attention);
                    lcd_gotoxy(17,0);		// caractre perso (ATTENTION) ligne 0
		    lcd_putchar(0);
		    lcd_gotoxy(18,0);
		    lcd_putchar(1);
		    lcd_gotoxy(17,1);           // caractre perso (ATTENTION) ligne 1
		    lcd_putchar(2);
		    lcd_gotoxy(18,1);
		    lcd_putchar(3);
		    lcd_gotoxy(16,2);           // caractre perso (ATTENTION) ligne 2
		    lcd_putchar(4);
		    lcd_gotoxy(17,2);
		    lcd_putchar(5);
		    lcd_gotoxy(18,2);
		    lcd_putchar(6);
		    lcd_gotoxy(19,2);
		    lcd_putchar(7);              
		    lcd_gotoxy(1,2);		// affichage de l'tat du test
		    lcd_putchar(etat);
		    EtatPORTD=EtatPORTD | 0b00000001;		// DEF = 1
      		    Ecrire_PCF8574(3,EtatPORTD);
      		    
      		    if (AC1 == 1) etat=1;
      		    if (AC2 == 1) etat=2;
      		    if (AC3 == 1) etat=5;
      		    	else etat=0;
      break;
      
      case 1 :
      	     if (AC1 == 1)
	      	{
      		sprintf(display_buffer_ligne0,"AC1=1");
       		sprintf(display_buffer_ligne1,"bouton enfonc");       
       		sprintf(display_buffer_ligne2,"");
      	 	sprintf(display_buffer_ligne3,"--> appel etage 1");
       		Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
       		EtatPORTD=EtatPORTD | 0b00010000;            // LED1 = 1
       	        Ecrire_PCF8574(3,EtatPORTD);
        	}
             else EtatPORTD=EtatPORTD & 0b11101111;          // LED1 = 0
                  Ecrire_PCF8574(3,EtatPORTD);
      	     
      	     if (AC2 == 1) etat=2;
      	     if (AC3 == 1) etat=5;
      	      	else etat=1;
                    
      break;
      
      case 2 :
      	     if (AC2 == 1)
	      	{
      		sprintf(display_buffer_ligne0,"AC2=1");
       		sprintf(display_buffer_ligne1,"bouton enfonc");       
       		sprintf(display_buffer_ligne2,"");
      	 	sprintf(display_buffer_ligne3,"--> appel etage 2");
       		Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
       		EtatPORTD=EtatPORTD | 0b00100000;            // LED2 = 1
       	        Ecrire_PCF8574(3,EtatPORTD);
        	}
             else EtatPORTD=EtatPORTD & 0b11011111;	     // LED2 = 0
                  Ecrire_PCF8574(3,EtatPORTD);
             
             if (AC1 == 1) etat=1;
      	     if (AC3 == 1) etat=5;
      	      	else etat=2;
                    
      break;
      
      case 5 :
      	     if (AC3 == 1)
	      	{
      		sprintf(display_buffer_ligne0,"AC3=1");
       		sprintf(display_buffer_ligne1,"bouton enfonc");       
       		sprintf(display_buffer_ligne2,"");
      	 	sprintf(display_buffer_ligne3,"--> appel etage 3");
       		Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
       		EtatPORTD=EtatPORTD | 0b01000000;            // LED3 = 1
       	        Ecrire_PCF8574(3,EtatPORTD);
        	}
             else EtatPORTD=EtatPORTD & 0b10111111;	     // LED3 = 0
                  Ecrire_PCF8574(3,EtatPORTD);
             
             if (AC1 == 1) etat=1;
      	     if (AC2 == 1) etat=2;
      	      	else etat=5;
                    
      break;     
   }
  };

AP1 = (Lire_PCF8574(0)&0b01000000);        // lecture PA6
AP2 = (Lire_PCF8574(0)&0b10000000);        // lecture PA7
AP3 = (Lire_PCF8574(1)&0b00000001);        // lecture PB0
AC1 = (Lire_PCF8574(1)&0b00000010);        // lecture PB1
AC2 = (Lire_PCF8574(1)&0b00000100);        // lecture PB2
AC3 = (Lire_PCF8574(1)&0b00001000);        // lecture PB3
PO1 = (Lire_PCF8574(0)&0b00001000);        // lecture PA3
PO2 = (Lire_PCF8574(0)&0b00010000);        // lecture PA4
PO3 = (Lire_PCF8574(0)&0b00100000);        // lecture PA5
VP1 = (Lire_PCF8574(2)&0b00000001);        // lecture PC0
VP2 = (Lire_PCF8574(2)&0b00000010);        // lecture PC1
VP3 = (Lire_PCF8574(2)&0b00000100);        // lecture PC2
PC1 = (Lire_PCF8574(0)&0b00000001);        // lecture PA0
PC2 = (Lire_PCF8574(0)&0b00000010);        // lecture PA1
PC3 = (Lire_PCF8574(0)&0b00000100);        // lecture PA2

EtatPORTA = (Lire_PCF8574(0));             // lecture du port A
EtatPORTB = (Lire_PCF8574(1));             // Lecture du port B
EtatPORTC = (Lire_PCF8574(2));             // Lecture du port C
EtatPORTD = (Lire_PCF8574(3));             // Lecture du port D
                                        
EtatPORTD=EtatPORTD | 0b00010000;	// LED1 = 1
EtatPORTD=EtatPORTD & 0b11101111;	// LED1 = 0		

EtatPORTD=EtatPORTD | 0b00100000;	// LED2 = 1
EtatPORTD=EtatPORTD & 0b11011111;	// LED2 = 0
                                       
EtatPORTD=EtatPORTD | 0b01000000;	// LED3 = 1
EtatPORTD=EtatPORTD & 0b10111111;	// LED3 = 0

EtatPORTD=EtatPORTD | 0b00000010;	// EL1 = 1
EtatPORTD=EtatPORTD & 0b11111101;	// EL1 = 0

EtatPORTD=EtatPORTD | 0b00000100;	// EL2 = 1
EtatPORTD=EtatPORTD & 0b11111011;	// EL2 = 0

EtatPORTD=EtatPORTD | 0b00001000;	// EL3 = 1
EtatPORTD=EtatPORTD & 0b11110111;	// EL3 = 0

EtatPORTD=EtatPORTD | 0b00000001;	// DEF = 1
EtatPORTD=EtatPORTD & 0b11111110;	// DEF = 0

Ecrire_PCF8574(3,EtatPORTD);
}

//fin du programme principal


// Sous-programmes
//----------------
    
unsigned char Lire_PCF8574(unsigned char add)          // Procdure de lecture du port I2C
{
  unsigned char entrees;
  i2c_start();
  i2c_write(0x41 | add << 1);
  entrees = i2c_read(0);
  i2c_stop();
  return entrees;    
} 


void Ecrire_PCF8574(unsigned char add, unsigned char valeur)           // Procdure d'criture sur le port I2C
{
  i2c_start();
  i2c_write(0x40 | add << 1);
  i2c_write(valeur);
  i2c_stop();
  delay_ms(10);
} 

/*

void EL1_egal_1()
{
unsigned char EtatPORTD;
EtatPORTD=EtatPORTD | 0b00000010;	//EL1=1 
Ecrire_PCF8574(PORTD,EtatPORTD); 	//EL1=1;
}         
 
*/


void init_CGRAM(char valeur[8][8])
 {
 unsigned char i,j;
 for (i=0;i<8;i++)
  {
   for (j=0;j<8;j++)
   	lcd_write_byte(0x40              + i, valeur[i][j]);
    }
 }
