/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.8a Evaluation
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 09/05/2007
Author  : Freeware, for evaluation and non-commercial use only
Company : 
Comments: 


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/

#include <90s8535.h>    // Microcontrleur
#include <delay.h>      // Fonction delai
#include <i2c.h>        // I2C
#include <ssi.h>	// librairie SSI
#include <lcd.h>	// Afficheur
#include <stdio.h>      // Afficheur

char display_buffer_ligne0[20]; 	   // tampon ligne 0 de l'afficheur
char display_buffer_ligne1[20]; 	   // tampon ligne 1 de l'afficheur
char display_buffer_ligne2[20]; 	   // tampon ligne 2 de l'afficheur
char display_buffer_ligne3[20]; 	   // tampon ligne 3 de l'afficheur

// I2C Bus functions
#asm
   .equ __i2c_port=0x12
   .equ __sda_bit=3
   .equ __scl_bit=7
#endasm

// Afficheur LCD
#asm
   .equ __lcd_port=0x15
#endasm

// Adresses des Ports I2C
#define AD_BASE_PCF8574		0x40
#define AD_I2C_PORTA		0
#define AD_I2C_PORTB		1
#define AD_I2C_PORTC		2
#define AD_I2C_PORTD		3

// Adresses des ports I2C
#define I2C_PORTA 0
#define I2C_PORTB 1
#define I2C_PORTC 2
#define I2C_PORTD 3

// Prototype des fonctions
//-------------------------
unsigned char Lire_PCF8574(unsigned char add);

void main(void)
{
// Declare your local variables here
unsigned char I;
unsigned char PC1,PC2,PC3;
unsigned char AC1,AC2,AC3;
                   
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x01;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x01;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x30;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 500,000 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Inverted
// OC1B output: Inverted
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0xF1;
TCCR1B=0x02;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// I2C Bus initialisation
i2c_init();

// LCD module initialisation
lcd_init(20);

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;




while (1)
  {
      PC1 = (Lire_PCF8574(I2C_PORTA)&0b00000001);        // lecture PA0
      PC2 = (Lire_PCF8574(I2C_PORTA)&0b00000010);        // lecture PA1
      PC3 = (Lire_PCF8574(I2C_PORTA)&0b00000100);        // lecture PA2
      AC1 = (Lire_PCF8574(I2C_PORTB)&0b00000010);        // lecture PB1
      AC2 = (Lire_PCF8574(I2C_PORTB)&0b00000100);        // lecture PB2
      AC3 = (Lire_PCF8574(I2C_PORTB)&0b00001000);        // lecture PB3
      
      sprintf(display_buffer_ligne0,"Programme ascenseur");
      sprintf(display_buffer_ligne1,"  initialisation");
      sprintf(display_buffer_ligne2,"--------------------");
      sprintf(display_buffer_ligne3,"     prog test");
      Affiche_LCD440(display_buffer_ligne0,display_buffer_ligne1,display_buffer_ligne2,display_buffer_ligne3);
      
      if (PINA.5==0)   // Montee
      { 
      	for(I=20;I<250;I=I+10)
      	{
      	PORTB.0 = 1;
      	delay_ms(200);
      	OCR1AL=I;
      	OCR1BL=0;
      	}              
      	
        delay_ms(2000);        
        
        for(I=250;I>20;I=I-10)
      	{
      	PORTB.0 = 1;
      	delay_ms(200);
      	OCR1AL=I;
      	OCR1BL=0;
      	}	 
      }
      
      else PORTB.0=0;  
      
      if (PINA.4==0)	// Descendre  
      { 
      	for(I=20;I<250;I=I+10)
      	{             
      	PORTB.0 = 1;
      	delay_ms(200);
        OCR1AL=0;
        OCR1BL=I;
  	}
        
        delay_ms(2000);
        
        for(I=250;I>20;I=I-10)
      	{
      	PORTB.0 = 1;
      	delay_ms(200);
      	OCR1AL=0;
      	OCR1BL=I;
      	}	 
      }
      
      else PORTB.0=0;	// Place your code here 
            
  };
}

unsigned char Lire_PCF8574(unsigned char add)
{
  unsigned char entrees;
  i2c_start();
  i2c_write(0x41 | add << 1);
  entrees = i2c_read(0);
  i2c_stop();
  return entrees;    
}
