/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 05/04/2007
Author  : Philippe Mariano                
Company : LYCEE Pierre Emile MARTIN       
Comments: 


Chip type           : AT90S8535
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the AT90S8535


#pragma used+
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSR=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR=9;
sfrb UCR=0xa;
sfrb USR=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions




// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib



// Adresse CGRAM de l'afficheur LCD
// --------------------------------

// Constantes en flash
//--------------------
// Caractres personnaliss placs dans la mmoire CGRAM du LCD
const unsigned char flecheHaut[8] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};    // @0 CGRAM
const unsigned char flecheBas[8] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};     // @1 CGRAM
const unsigned char Symbole_Barre_Graphe[8] = {0x00, 0x0E, 0x0A, 0x0A, 0x0A, 0x0A, 0x1B, 0x00}; // @2 CGRAM
const unsigned char Barre_graphe_niveau2[8] = {0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00}; // @3 CGRAM
const unsigned char Barre_graphe_niveau3[8] = {0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00}; // @4 CGRAM
const unsigned char Barre_graphe_niveau4[8] = {0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00}; // @5 CGRAM
const unsigned char Barre_graphe_niveau5[8] = {0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00}; // @6 CGRAM
const unsigned char Barre_graphe_niveau6[8] = {0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00}; // @7 CGRAM

// Declare your global variables here

void main(void)
{
// Declare your local variables here
unsigned char i,j;


// LCD module initialization
lcd_init(20);

// Chargement de la mmoire CGRAM de l'afficheur avec les 
// caractres personaliss
for (i=0;i<8;i++)
lcd_write_byte(0x40 + i, flecheHaut[i]);
for (i=0;i<8;i++)
lcd_write_byte(0x48 + i, flecheBas[i]); 
for (i=0;i<8;i++)
lcd_write_byte(0x50 + i, Barre_graphe_niveau2[i]);
for (i=0;i<8;i++)
lcd_write_byte(0x58 + i, Barre_graphe_niveau3[i]);
for (i=0;i<8;i++)
lcd_write_byte(0x60 + i, Barre_graphe_niveau4[i]);
for (i=0;i<8;i++)
lcd_write_byte(0x68 + i, Barre_graphe_niveau5[i]); 
for (i=0;i<8;i++)
lcd_write_byte(0x70 + i, Barre_graphe_niveau6[i]);
for (i=0;i<8;i++)
lcd_write_byte(0x78 + i, Symbole_Barre_Graphe[i]);


      lcd_gotoxy(0,0);
      lcd_putchar('T');
      lcd_gotoxy(0,1);
      lcd_putchar('E');
      lcd_gotoxy(0,2);
      lcd_putchar('S');
      lcd_gotoxy(0,3);
      lcd_putchar('T');
      lcd_gotoxy(19,0);
      lcd_putchar(0);
      lcd_gotoxy(19,3);
      lcd_putchar(1);  
      
      j=5;
      for (i=2;i<7;i++)
      {
        lcd_gotoxy(j,0);
        lcd_putchar(i); 
        j++;    
      } 
      
      j =0; 
      for (i=6;i>1;i--)
      { 
        lcd_gotoxy(j+10,0);
        lcd_putchar(i);
        j++;     
      }; 
      
      for(i=9;i<11;i++)
      {
       for (j=1;j<3;j++)
       {  
        lcd_gotoxy(i,j);
        lcd_putchar(6);
       } 
      }
      
       
      for (j=5;j<15;j++)
      { 
        lcd_gotoxy(j,3);
        lcd_putchar(1);    
      };
      
}
